#!/usr/bin/perl

unshift(@INC,'.');
use AdminAgent ;

local %MsgIdList ;

$MailFile = "/var/mail/apache" ;
open(MAIL,"<$MailFile") || die "Could not open MailFile" ;

$Status = "Init" ;
$Debug = "YES" ;
$Mode="Read" ;
$ConfigFile = "AdminAgent.cfg" ;

if ( $Debug ) {
    open(PROTO,">>/usr/tmp/apache_sysadmin") || die "Could not open ProtoCol File" ;
}

&open_database($ConfigFile,$Mode) ;

while(<MAIL>) {
    $Message .= $_ if ( $Status eq "Handle" ) ;
    if ( m/^FROM\s+([^\s]+)/i ) { 
       if ( $Status eq "Handle" ) {
          &WhatDo();
       }
       $Sender = $1 ;
       $Status = "NewMessage" ;
       print PROTO "SENDER: $Sender\n" if ( $Debug ) ;
    }
    $MsgId = $1 if ( m/^Message-Id:\s+([^\s]+)/i ) ;
    if ( m/^subject:\s+([^\s]+)/i ) {
       $Subject = $1 ;
       $Status = "Message" ;
       print PROTO "SUBJECT: $Subject\n" if ( $Debug );
       if ( exist_Subject($Subject) ) {
          $Status = "Handle" ;
          $Message = "" ;
          print PROTO "HANDLE: $Sender ==> $Subject \n" if ( $Debug ) ;
       } else {
		  print PROTO "HANDLE: $Sender ==> $Subject is not registered \n" if ( $Debug ) ;
	   }
    }
}

if ( $Status eq "Handle" ) {
   &WhatDo();
}

&cleanup();
close(PROTO);
&close_database();
close(MAIL) ;


sub WhatDo {
    print PROTO "SENDER: $Sender \n" if ( $Debug ) ;
    if ( &exist_MsgId($MsgId) ) {
       print PROTO "WHATDO: Entry $MsgId has been just handled \n" if ( $Debug ) ;
    } else {
       print PROTO "WHATDO: Handling Request $MsgId\n" if ( $Debug ) ;
       &HandleMessage($Message,$Sender);
       
    }
    $MsgIdList{$MsgId} = "NOP" ; # for now not used 
    print PROTO "$MsgId pushed on Array MSGID-List \n" if ( $Debug ) ;
}

sub HandleMessage {
    my ( $Message,$Sender) = @_ ;
    my ($Action,$Param,$ScriptId) ;

    my $UserId = $Sender ;
    $UserId =~ s/@[^@]+$// ;
    
    do {
        ($Action,$Param,$ScriptId) = get_Actions($Subject,"Next") ;
		print "$Action ++++ $Param \n" ;
        if ( $Action & $Param ) {
           print PROTO "REQUEST: Testing for $Action $Param\n" if ( $Debug) ;
           if (  ( $Message =~ m/$Action/i ) & ( $Message =~ m/$Param/i ) ) {
              if ( is_auth($UserId,$ScriptId) ) {
                 ExecuteProgram($ScriptId) ;
                 &RegisterExecution($Subject,$Action,$Param,$ScriptId,$MsgId) ; 
                 return 1 ;
              } else {
                 print PROTO "$UserId is not authorised to use Script: $ScriptId \n" ;
                 return 0 ;
              }
           }
        }
    } while ( $Action & $Param ) ;
    print PROTO "Wrong Message Body \n" ;
    return 0 ;
}


sub ExecuteProgram {
    my ( $ScriptId ) = @_ ;
    
    $Script = get_Script($ScriptId) ;
	print PROTO "Executing $Script \n" if ( $Debug ) ;
    system($Script);
}

sub RegisterExecution {
    my ($Subject,$Action,$Param,$ScriptId,$MsgId) = @_ ;
    my $Script = get_Script($ScriptId) ;

    my ($day, $month, $year) = (localtime)[3,4,5] ;
    my $Date = sprintf("%02d/%02d/%04d",$day,$month+1,$year+1900) ;
    
    &add_MsgId($MsgId,$Subject,$Action,$Param,$Date,$Script);

}

sub cleanup {
    @List = list_MsgIds() ;
	foreach $Element ( @List ) {
			if ( $MsgIdList{$Element} ) {
			   &report("Keeping: $Element \n") ;
			} else {
			   &report("Destroying: $Element \n") ;
			   &del_MsgId($Element) ;
			}
	}
}

sub report {
    ( $Message ) = @_ ;
	print PROTO $Message if ( $Debug) ;
}
